<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class hwdvids_BE_videos
{
   /**
	* show videos
	*/
	function showvideos($option)
	{
		global $database, $mainframe, $limit, $limitstart;
  		$db =& JFactory::getDBO();

		$search 		= $mainframe->getUserStateFromRequest( "search{$option}", 'search', '' );
		$search 		= $db->getEscaped( trim( strtolower( $search ) ) );

		$category_id = JRequest::getInt( 'category_id', 0, 'post' );

		$db->SetQuery( "SELECT count(*)"
							. "\nFROM #__hwdvidsvideos AS a"
							. "\nWHERE a.published 	>= 0"
							);
		$total = $db->loadResult();
		echo $db->getErrorMsg();

		$where = array(
		"a.published 	>= 0",
		);

		$catfilter = "";
		if ($category_id !== 0) {
			$catfilter = "\nAND a.category_id = ".$category_id;
		}

		if ($search) {
			$where[] = "LOWER(a.title) LIKE '%$search%'";
				$db->SetQuery( "SELECT count(*)"
							. "\nFROM #__hwdvidsvideos AS a"
							. (count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "")
							. $catfilter
							);
				$total = $db->loadResult();
				echo $db->getErrorMsg();
		}

		$pageNav = new mosPageNav( $total, $limitstart, $limit );

		$query = "SELECT a.*"
				. "\nFROM #__hwdvidsvideos AS a"
				. ( count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "")
				. $catfilter
				. "\nORDER BY a.date_uploaded DESC"
							;
		$db->SetQuery( $query, $pageNav->limitstart, $pageNav->limit );
		$rows = $db->loadObjectList();

		$query = "SELECT a.*"
				. "\nFROM #__hwdvidsvideos AS a"
				. ( count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "")
				. $catfilter
			    . "\nAND a.featured = 1"
				. "\nORDER BY a.ordering ASC"
							;
		$db->SetQuery( $query );
		$rows_feat = $db->loadObjectList();

		hwdvids_HTML::showvideos($option, $rows, $rows_feat, $pageNav, $search, $catfilter, $category_id);
	}
   /**
	* edit videos
	*/
	function editvideos($option, $cid)
	{
		global $mosConfig_live_site, $mainframe, $mainframe;
  		$db =& JFactory::getDBO();
		$my = & JFactory::getUser();
		$row = new hwdvids_video( $db );
		$row->load( $cid );

		// fail if checked out not by 'me'
		if ($row->isCheckedOut( $my->id )) {
			//BUMP needs change for multilanguage support
			$mainframe->enqueueMessage('This video is currently being editted by another user');
			$mainframe->redirect( JURI::root( true ) . '/administrator/index2.php?option='.$option.'&task=videos' );
		}

		$db->SetQuery("SELECT *"
							. "\n FROM #__hwdvidsvideos"
							. "\n WHERE id = $cid");
		$row = $db->loadObject();

		$db->SetQuery("SELECT category_name"
							. "\n FROM #__hwdvidscategories"
							. "\n WHERE id = $row->category_id");
		$cat = $db->loadObject();

		if ($row->user_id == 0) {
			$usr->username = "Guest";
		} else {
			$db->SetQuery("SELECT username"
								. "\n FROM #__users"
								. "\n WHERE id = $row->user_id");
			$usr = $db->loadObject();
		}

		$db->SetQuery( "SELECT count(*)"
							. "\nFROM #__hwdvidsfavorites"
							. "\nWHERE videoid = $cid"
							);
		$favs = $db->loadResult();
		echo $db->getErrorMsg();
		if (empty($favs)) {$favs = 0;}

		$db->SetQuery( "SELECT count(*)"
							. "\nFROM #__hwdvidsflagged_videos"
							. "\nWHERE videoid = $cid"
							);
		$flagged = $db->loadResult();
		echo $db->getErrorMsg();
		if (empty($flagged)) {$flagged = 0;}



$users = array();
$users[] = JHTML::_('select.option', '0', 'Guest');
$db->setQuery( "SELECT id AS value, username AS text FROM #__users" );
$users = array_merge( $users, $db->loadObjectList() );
$selected = $row->user_id;
$uploader_list = JHTML::_('select.genericlist', $users, 'user_id', 'class="inputbox"', 'value', 'text', $selected);











		$draw_thumbnail = JRequest::getInt( 'draw_thumbnail', 0, 'post' );
		$output4 = null;

		$cmd_ffmpeg=null;
		if ($draw_thumbnail == "1") {
			// get server config
			$s = hwd_vs_SConfig::get_instance();
			// start thumbnail generation
			$path_new = JPATH_SITE."/hwdvideos/uploads/".$row->video_id.".flv";
			$thumb_position = Jrequest::getVar( 'time', '0:00:02' );
			$path_thumb = JPATH_SITE."/hwdvideos/thumbs/tmp_".$row->video_id.".jpg";
			$path_thumb_real = JPATH_SITE."/hwdvideos/thumbs/".$row->video_id.".jpg";

			// redraw thumbnail image
			$cmd_ffmpeg = "$s->ffmpegpath -i $path_new -ss $thumb_position -t 00:00:01 -s 120x90 -r 1 -f mjpeg $path_thumb";
			@exec("$cmd_ffmpeg 2>&1", $output4);

		   /**
			* Check thumbnail exists
			* Use alternative method if necessary
			**/
			if ( @!file_exists($path_thumb) || (@filesize($path_thumb) == 0) ) {
				$cmd_ffmpeg = "$s->ffmpegpath -i $path_new -ss $thumb_position -t 00:00:01 -s 120x90 -r 1 -f image2 $path_thumb";
				//execute and record output to variable
				@exec("$cmd_ffmpeg 2>&1", $output4);
			}

		   /**
			* Check thumbnail exists and has a positive filesize
			* If missing or empty then run both methods again at 2 seconds
			**/
			$sec = 2;
			$sec2 = $sec / 2;
			$sec2 = @round($sec2);
			$thumb_position = hwdvids_BE_videos::sec2hms($sec2);
			if ( @!file_exists($path_thumb) || (@filesize($path_thumb) == 0) ) {
				$cmd_ffmpeg = "$s->ffmpegpath -i $path_new -ss $thumb_position -t 00:00:01 -s 120x90 -r 1 -f mjpeg $path_thumb";
				//execute and record output to variable
				@exec("$cmd_ffmpeg 2>&1", $output4);
			}
			if ( @!file_exists($path_thumb) || (@filesize($path_thumb) == 0) ) {
				$cmd_ffmpeg = "$s->ffmpegpath -i $path_new -ss $thumb_position -t 00:00:01 -s 120x90 -r 1 -f image2 $path_thumb";
				//execute and record output to variable
				@exec("$cmd_ffmpeg 2>&1", $output4);
			}
			// remove existing thumbnail
			if ( @file_exists($path_thumb_real) ) {
				@unlink ($path_thumb_real);
			}
			// rename tmp image and output result
			if ( @!file_exists($path_thumb_real) ) {
				if ( @rename($path_thumb, $path_thumb_real) ) {
					echo "<script> alert('Thumbnail was successfully automatically generated'); </script>\n";
				} else {
					echo "<script> alert('Thumbnail could not be automatically generated'); </script>\n";
				}
			}
		}
		$upld_thumbnail = JRequest::getInt( 'upld_thumbnail', 0, 'post' );
		if ($upld_thumbnail == "1") {

			if ($_FILES['thumbnail_file']['tmp_name'] !== "") {
				$base_Dir = HWDVIDSPATH.'/../../hwdvideos/thumbs/';
				if (@explode(",", $row->video_id)) {
					$data = explode(",", $row->video_id);
					$videocode = $data[0];
				} else { $videocode = $row->video_id; }

				// update sql if necessary
				if ($row->video_type == "local") {
					$upload_result = hwd_vs_tools::uploadFile("thumbnail_file", $videocode, $base_Dir, 2, "jpg", 1);
					if ($upload_result[0] == "0") {
						$msg = $upload_result[1];
						$mainframe->enqueueMessage($msg);
						$mainframe->redirect( 'index.php?option=com_hwdvideoshare&Itemid='.$Itemid.'&task=editvidsA&hidemainmenu=1&cid='.$row->id );
					}
				} else if ($row->video_type == "remote") {
					$videocode = "remote-".$row->id;
					$upload_result = hwd_vs_tools::uploadFile("thumbnail_file", $videocode, $base_Dir, 2, "jpg", 1);
					if ($upload_result[0] == "0") {
						$msg = $upload_result[1];
						$mainframe->enqueueMessage($msg);
						$mainframe->redirect( 'index.php?option=com_hwdvideoshare&Itemid='.$Itemid.'&task=editvidsA&hidemainmenu=1&cid='.$row->id );
					}
					$data[1] = JURI::root() . "hwdvideos/thumbs/".$videocode.".jpg";
					$new_video_id = implode(",", $data);

					// update db with new thumbnail
					$db->SetQuery("UPDATE #__hwdvidsvideos SET video_id = '$new_video_id' WHERE id = $row->id");
					$db->Query();
					if ( !$db->query() ) {
						echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
						exit();
					}

				} else if ($row->video_type == "swf") {
					$upload_result = hwd_vs_tools::uploadFile("thumbnail_file", $videocode, $base_Dir, 2, "jpg", 1);
					if ($upload_result[0] == "0") {
						$msg = $upload_result[1];
						$mainframe->enqueueMessage($msg);
						$mainframe->redirect( 'index.php?option=com_hwdvideoshare&Itemid='.$Itemid.'&task=editvidsA&hidemainmenu=1&cid='.$row->id );
					}
				} else {
					$upload_result = hwd_vs_tools::uploadFile("thumbnail_file", $videocode, $base_Dir, 2, "jpg", 1);
					if ($upload_result[0] == "0") {
						$msg = $upload_result[1];
						$mainframe->enqueueMessage($msg);
						$mainframe->redirect( 'index.php?option=com_hwdvideoshare&Itemid='.$Itemid.'&task=editvidsA&hidemainmenu=1&cid='.$row->id );
					}
					$data[1] = JURI::root() . "hwdvideos/thumbs/".$videocode.".jpg";
					$new_video_id = implode(",", $data);

					// update db with new thumbnail
					$db->SetQuery("UPDATE #__hwdvidsvideos SET video_id = '$new_video_id' WHERE id = $row->id");
					$db->Query();
					if ( !$db->query() ) {
						echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
						exit();
					}

				}
				echo "<script> alert('Thumbnail was successfully uploaded'); </script>\n";
			} else {
				echo "<script> alert('Thumbnail could not be uploaded'); </script>\n";
			}
		}

		$tp_thumbnail_updt = JRequest::getInt( 'tp_thumbnail_updt', 0, 'post' );
		if ($tp_thumbnail_updt == "1") {

			$thumbnail_url = Jrequest::getVar( 'thumbnail_url', '' );
			if (!hwd_vs_tools::is_valid_url($thumbnail_url)) {
				$msg = _HWDVIDS_ALERT_TURLWRONG;
				echo "<script> alert('".$msg."'); window.history.go(-1); </script>\n";
				return;
			}

			if (@explode(",", $row->video_id)) {
				$data = explode(",", $row->video_id);
				$thumbnail = $data[1];
			} else { $thumbnail = "ERROR"; }

			$data[1] = $thumbnail_url;
			$video_id_updt = implode(",", $data);

			// update db with new thumbnail
			$db->SetQuery("UPDATE #__hwdvidsvideos SET video_id = '$video_id_updt' WHERE id = $row->id");
			$db->Query();

			if ( !$db->query() ) {
				echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
				exit();
			}
		}

		hwdvids_HTML::editvideos($option, $row, $cat, $usr, $favs, $flagged, $uploader_list, $output4, $cmd_ffmpeg);
	}
   /**
	* save videos
	*/
	function savevideo($option)
	{
		global $mainframe;
		$db = & JFactory::getDBO();
		$row = new hwdvids_video($db);

		// bind it to the table
		if (!$row -> bind($_POST)) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		// store it in the db
		if (!$row -> store()) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		$row->checkin();

		include(HWDVS_ADMIN_PATH.'/maintenance/recount.class.php');
		hwd_vs_recount::recountVideosInCategory($row->category_id);

		$mainframe->enqueueMessage(_HWDVIDS_ALERT_VIDSAVED);
		$mainframe->redirect( JURI::root( true ) . '/administrator/index2.php?option='.$option.'&task=videos' );

	}
   /**
	* cancel videos
	*/
	function cancelvideo($option)
	{
		global $mainframe;
		$db = & JFactory::getDBO();
		$row = new hwdvids_video( $db );
		$row->bind( $_POST );
		$row->checkin();

		$mainframe->enqueueMessage($msg);
		$mainframe->redirect( JURI::root( true ) . '/administrator/index2.php?option='.$option.'&task=videos' );

	}
   /**
	* publish/unpublish videos
	*/
	function publishvid( $cid=null, $publish=1,  $option ) {
		global $database, $mainframe, $task;
  		$db =& JFactory::getDBO();
		$my = &JFactory::getUser();

		if (count( $cid ) < 1) {
			$action = $publish == 1 ? 'publish' : ($publish == -1 ? 'archive' : 'unpublish');
			echo "<script> alert('Select an item to $action'); window.history.go(-1);</script>\n";
			exit;
		}

		$total = count ( $cid );
		$cids = implode( ',', $cid );

		$db->setQuery( "UPDATE #__hwdvidsvideos"
						. "\nSET published =" . intval( $publish )
						. "\n WHERE id IN ( $cids )"
						. "\n AND ( checked_out = 0 OR ( checked_out = $my->id ) )"
						);
		if (!$db->query()) {
		echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
		}

		switch ( $publish ) {
			case 1:
				$msg = $total ._HWDVIDS_ALERT_ADMIN_VIDPUB." ";
				break;

			case 0:
			default:
				$msg = $total ._HWDVIDS_ALERT_ADMIN_VIDUNPUB." ";
				break;
		}

		if (count( $cid ) == 1) {
			$row = new hwdvids_video( $db );
			$row->checkin( $cid[0] );
		}
		$mainframe->enqueueMessage($msg);
		$mainframe->redirect( JURI::root( true ) . '/administrator/index2.php?option='.$option.'&task=videos' );
	}
   /**
	* feature/unfeature videos
	*/
	function featurevid( $cid=null, $publish=1,  $option ) {
		global $database, $task, $mainframe;
  		$db =& JFactory::getDBO();
		$my = &JFactory::getUser();

		if (count( $cid ) < 1) {
			$action = $publish == 1 ? 'feature' : ($publish == -1 ? 'archive' : 'unfeature');
			echo "<script> alert('Select an item to $action'); window.history.go(-1);</script>\n";
			exit;
		}

		$total = count ( $cid );
		$cids = implode( ',', $cid );

		$db->setQuery( "UPDATE #__hwdvidsvideos"
						. "\nSET featured =" . intval( $publish )
						. "\n WHERE id IN ( $cids )"
						. "\n AND ( checked_out = 0 OR ( checked_out = $my->id ) )"
						);
		if (!$db->query()) {
		echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
		}

		switch ( $publish ) {
			case 1:
				$msg = $total ._HWDVIDS_ALERT_ADMIN_VIDFEAT." ";
				break;

			case 0:
			default:
				$msg = $total ._HWDVIDS_ALERT_ADMIN_VIDUNFEAT." ";
				break;
		}


		// update all non featured videos to ordering zero
		$db->setQuery( "UPDATE #__hwdvidsvideos"
						. "\n SET ordering = 0"
						. "\n WHERE featured = 0"
						);
		if (!$db->query()) {
		echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
		}
		// get the maximum ordering value
		$db->setQuery( "SELECT MAX(ordering) FROM #__hwdvidsvideos"
						. "\n WHERE featured = 1"
						);
		$maxorder = $db->loadResult();

		// get all featured videos
		$db->setQuery( "SELECT * FROM #__hwdvidsvideos"
						. "\n WHERE id IN ( $cids )"
						. "\n AND ordering = 0"
						);
		$rows = $db->loadObjectList();
		// reorder all featured videos that are set to zero order
		$neworder=$maxorder+1;
		for($i=0, $n=count( $rows ); $i < $n; $i++) {
		$row = $rows[$i];

			$db->setQuery( "UPDATE #__hwdvidsvideos"
							. "\n SET ordering =" . $neworder
							. "\n WHERE id =" . $row->id
							);
			if (!$db->query()) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
			}

		$neworder++;
		}


		if (count( $cid ) == 1) {
			$row = new hwdvids_video( $db );
			$row->checkin( $cid[0] );
		}
		$mainframe->enqueueMessage($msg);
		$mainframe->redirect( JURI::root( true ) . '/administrator/index2.php?option='.$option.'&task=videos' );

	}
   /**
	* delete videos
	*/
	function deletevids($option, $cid)
	{
		global $mainframe;
  		$db =& JFactory::getDBO();

		$total = count( $cid );
		$events = join(",", $cid);

		$db->SetQuery("UPDATE #__hwdvidsvideos SET approved = 'deleted', published = 0, featured = 0 WHERE id IN ($events)");
		$db->Query();

		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$msg = $total ._HWDVIDS_ALERT_ADMIN_VIDDEL." ";
		$mainframe->enqueueMessage($msg);
		$mainframe->redirect( JURI::root( true ) . '/administrator/index2.php?option='. $option.'&task=videos' );
	}
function orderForum($uid, $inc, $option)
{
    global $mainframe;
	$db = & JFactory::getDBO();
    $row = new hwdvids_video($db);
    $row->load($uid);
    $row->move($inc,"featured=1");

	$query = 'SELECT id, hwdvidsvideos'
			. ' FROM #__hwdvidscategories'
			. ' WHERE featured=1'
			. ' ORDER BY ordering ASC'
			;

	$db->SetQuery($query);
	$rows = $db->loadObjectList();

	for ($i=0, $n=count($rows); $i < $n; $i++) {
		$cid = (int)$rows[$i]->id;

		// update ordering
		$db->SetQuery("UPDATE #__hwdvidsvideos SET ordering = $i WHERE id = $cid");
		$db->Query();
		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}
	}

	$mainframe->redirect( JURI::root( true ) . '/administrator/index2.php?option=com_hwdvideoshare&task=videos' );
}

   /**
	* edit videos
	*/
	function changeuserselect($cid, $option)
	{
		global $mosConfig_live_site, $mainframe, $mainframe;
  		$db =& JFactory::getDBO();
		$my = & JFactory::getUser();

		$row = new hwdvids_video( $db );
		$row->load( $cid );



$users = array();
$users[] = JHTML::_('select.option', '0', 'Guest');
$db->setQuery( "SELECT id AS value, username AS text FROM #__users" );
$users = array_merge( $users, $db->loadObjectList() );
$selected = $row->user_id;
$uploader_list = JHTML::_('select.genericlist', $users, 'user_id', 'class="inputbox"', 'value', 'text', $selected);






echo $uploader_list;exit;

	}

   /**
	* Convert seconds to HOURS:MINUTES:SECONDS format
	**/
	function sec2hms ($sec, $padHours = false)
	{

    // holds formatted string
    $hms = "";

    // there are 3600 seconds in an hour, so if we
    // divide total seconds by 3600 and throw away
    // the remainder, we've got the number of hours
    $hours = intval(intval($sec) / 3600);

    // add to $hms, with a leading 0 if asked for
    $hms .= ($padHours)
          ? str_pad($hours, 2, "0", STR_PAD_LEFT). ':'
          : $hours. ':';

    // dividing the total seconds by 60 will give us
    // the number of minutes, but we're interested in
    // minutes past the hour: to get that, we need to
    // divide by 60 again and keep the remainder
    $minutes = intval(($sec / 60) % 60);

    // then add to $hms (with a leading 0 if needed)
    $hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT). ':';

    // seconds are simple - just divide the total
    // seconds by 60 and keep the remainder
    $seconds = intval($sec % 60);

    // add to $hms, again with a leading 0 if needed
    $hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT);

    // done!
    return $hms;
	}

	function createThumbs( $pathToImages, $pathToThumbs, $thumbWidth )
	{
		  // echo "Creating thumbnail for $pathToImages <br />";

		  // load image and get image size
		  $img = imagecreatefromjpeg( $pathToImages );
		  $width = imagesx( $img );
		  $height = imagesy( $img );

		  // calculate thumbnail size
		  $new_width = $thumbWidth;
		  $new_height = floor( $height * ( $thumbWidth / $width ) );

		  // create a new temporary image
		  $tmp_img = imagecreatetruecolor( $new_width, $new_height );

		  // copy and resize old image into new image
		  imagecopyresized( $tmp_img, $img, 0, 0, 0, 0, $new_width, $new_height, $width, $height );

		  // save thumbnail into a file
		  imagejpeg( $tmp_img, $pathToThumbs );


	}
}
?>