<?php
/**
 *    @version 2.1.1 Build 21106 Alpha [ Drury ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

global $limit, $limitstart, $smarty, $c;

define( 'HWDVS_ADMIN_PATH', dirname(__FILE__) );
define( 'HWDVIDSPATH', HWDVS_ADMIN_PATH.'/../../../components/com_hwdvideoshare' );

require_once( $mainframe->getPath( 'admin_html' ) );
require_once( $mainframe->getPath( 'class' ) );

require_once(HWDVS_ADMIN_PATH.'/../../includes/pageNavigation.php');

require_once(HWDVS_ADMIN_PATH.'/config.hwdvideoshare.php');
require_once(HWDVS_ADMIN_PATH.'/serverconfig.hwdvideoshare.php');
$c = hwd_vs_Config::get_instance();
$db =& JFactory::getDBO();
/**
 * Load the language file
 */
if ($c->hwdvids_language_path == "joomfish" && file_exists(HWDVS_ADMIN_PATH.'/../../../components/com_hwdvideoshare/languages/'.$mainframe->getCfg('lang').'.php')) {
    include(HWDVS_ADMIN_PATH.'/../../../components/com_hwdvideoshare/languages/'.$mainframe->getCfg('lang').'.php');
} else if (file_exists(HWDVS_ADMIN_PATH.'/../../../hwdvideos/plugin/language/'.$c->hwdvids_language_path.'/'.$c->hwdvids_language_file.'.php')) {
	include(HWDVS_ADMIN_PATH.'/../../../hwdvideos/plugin/language/'.$c->hwdvids_language_path.'/'.$c->hwdvids_language_file.'.php');
} else {
	include(HWDVS_ADMIN_PATH.'/../../../components/com_hwdvideoshare/core/english.php');
}
// check version compatibiliy
require_once(HWDVS_ADMIN_PATH.'/../../../components/com_hwdvideoshare/mvc/controller/access.php');
if ( hwd_vs_access::checkJversion() > 0 ) {
	hwdvids_HTML::noncompat($option);
	return;
}
	$request_array = JRequest::get( 'request' );
	@$cid 	= $request_array['cid'];

  	$limit = $mainframe->getUserStateFromRequest("viewlistlimit", 'limit', 10);
 	$limitstart = $mainframe->getUserStateFromRequest("viewlimitstart", 'limitstart', 0);

	//$limit = intval( mosGetParam( $_REQUEST, 'limit', 15 ) );
	//$limitstart = intval( mosGetParam( $_REQUEST, 'limitstart', 0 ) );

	$task 	= JRequest::getCmd( 'task' );

// setup template system
require_once(HWDVS_ADMIN_PATH.'/../../../components/com_hwdvideoshare/core/templates/libs/Smarty.class.php');
$smarty = new Smarty;
$smarty->compile_check = true;
$smarty->debugging = false;
$smarty->template_dir = HWDVS_ADMIN_PATH.'/templates';
$smarty->compile_dir = HWDVS_ADMIN_PATH.'/../../../components/com_hwdvideoshare/core/templates/templates_c';
$smarty->cache_dir = HWDVS_ADMIN_PATH.'/../../../components/com_hwdvideoshare/core/templates/cache';
$smarty->config_dir = HWDVS_ADMIN_PATH.'/../../../components/com_hwdvideoshare/core/templates/configs';
$smarty->clear_compiled_tpl();
require_once(HWDVS_ADMIN_PATH.'/../../../components/com_hwdvideoshare/mvc/view/admin_templates.php');

$db->SetQuery( "SELECT value FROM #__hwdvidsgs WHERE setting = \"initialise_now\"" );
$c->initialise_now = $db->loadResult();
echo $db->getErrorMsg();

// check for initialisation request
if ( $c->initialise_now == "1" && $task !== "initialise_now" ) {
	hwdvids_HTML::initialise($option);
	return;
} else if ( $c->initialise_now == "1" && $task == "initialise_now" ) {
	initialise_setup();
	return;
}
		switch($task)
		{
			/** homepage */
			case 'homepage':
				checkdirstructure();
				homepage($option);
				break;

			/** videos functions */
			case "videos":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
				hwdvids_BE_videos::showvideos($option);
				break;
			case "editvidsA":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
				hwdvids_BE_videos::editvideos($option, $cid);
				break;
			case "editvids":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
				hwdvids_BE_videos::editvideos($option, $cid[0]);
				break;
			case "savevid":
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
				hwdvids_BE_videos::savevideo($option);
				break;
			case "cancelvid":
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
				hwdvids_BE_videos::cancelvideo($option);
				break;
			case "publish":
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
				hwdvids_BE_videos::publishvid( $cid, 1, $option );
				break;
  			case "unpublish":
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
				hwdvids_BE_videos::publishvid( $cid, 0, $option );
				break;
			case "feature":
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
				hwdvids_BE_videos::featurevid( $cid, 1, $option );
				break;
  			case "unfeature":
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
				hwdvids_BE_videos::featurevid( $cid, 0, $option );
				break;
			case "delete":
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
				hwdvids_BE_videos::deletevids($option, $cid);
				break;
    		case "order_f_up":
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
        		hwdvids_BE_videos::orderForum($cid[0], -1, $option);
				break;
		    case "order_f_down":
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
        		hwdvids_BE_videos::orderForum($cid[0], 1, $option);
        		break;
		    case "changeuserselect":
				require(HWDVS_ADMIN_PATH."/source/controllers/videos.php");
        		hwdvids_BE_videos::changeuserselect($cid, $option);
        		break;


			/** category functions */
			case "categories":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/categories.php");
				hwdvids_BE_cats::showcategories($option);
				break;
			case "editcatA":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/categories.php");
				hwdvids_BE_cats::editcategories($option, $cid);
				break;
			case "editcat":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/categories.php");
				hwdvids_BE_cats::editcategories($option, $cid[0]);
				break;
			case "newcat":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/categories.php");
				hwdvids_BE_cats::editcategories($option, 0);
				break;
			case "savecat":
				require(HWDVS_ADMIN_PATH."/source/controllers/categories.php");
				hwdvids_BE_cats::savecategories($option);
				break;
			case "cancelcat":
				require(HWDVS_ADMIN_PATH."/source/controllers/categories.php");
				hwdvids_BE_cats::cancelcat($option);
				break;
			case "deletecat":
				require(HWDVS_ADMIN_PATH."/source/controllers/categories.php");
				hwdvids_BE_cats::deletecategories($option, $cid);
				break;
			case "publishcat":
				require(HWDVS_ADMIN_PATH."/source/controllers/categories.php");
				hwdvids_BE_cats::publishcategory( $cid, 1, $option );
				break;
  			case "unpublishcat":
				require(HWDVS_ADMIN_PATH."/source/controllers/categories.php");
				hwdvids_BE_cats::publishcategory( $cid, 0, $option );
				break;
    		case "orderup":
				require(HWDVS_ADMIN_PATH."/source/controllers/categories.php");
        		hwdvids_BE_cats::orderForum($cid[0], -1, $option);
				break;
		    case "orderdown":
				require(HWDVS_ADMIN_PATH."/source/controllers/categories.php");
        		hwdvids_BE_cats::orderForum($cid[0], 1, $option);
        		break;

			/** group functions */
			case "groups":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/groups.php");
				hwdvids_BE_groups::showgroups($option);
				break;
			case "editgrpA":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/groups.php");
				hwdvids_BE_groups::editgroups($option, $cid);
				break;
			case "editgrp":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/groups.php");
				hwdvids_BE_groups::editgroups($option, $cid[0]);
				break;
			case "savegrp":
				require(HWDVS_ADMIN_PATH."/source/controllers/groups.php");
				hwdvids_BE_groups::savegroup($option);
				break;
			case "cancelgrp":
				require(HWDVS_ADMIN_PATH."/source/controllers/groups.php");
				hwdvids_BE_groups::cancelgrp($option);
				break;
			case "publishg":
				require(HWDVS_ADMIN_PATH."/source/controllers/groups.php");
				hwdvids_BE_groups::publishg( $cid, 1, $option );
				break;
			case "unpublishg":
				require(HWDVS_ADMIN_PATH."/source/controllers/groups.php");
				hwdvids_BE_groups::publishg( $cid, 0, $option );
				break;
			case "featureg":
				require(HWDVS_ADMIN_PATH."/source/controllers/groups.php");
				hwdvids_BE_groups::featureg( $cid, 1, $option );
				break;
  			case "unfeatureg":
				require(HWDVS_ADMIN_PATH."/source/controllers/groups.php");
				hwdvids_BE_groups::featureg( $cid, 0, $option );
				break;
			case "deletegroups":
				require(HWDVS_ADMIN_PATH."/source/controllers/groups.php");
				hwdvids_BE_groups::deletegroups($option, $cid);
				break;

			/** setting functions */
			case "serversettings":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/settings.php");
				hwdvids_BE_settings::showserversettings($option);
				break;
			case "saveserver":
				require(HWDVS_ADMIN_PATH."/source/controllers/settings.php");
				hwdvids_BE_settings::saveserver($option, $ffmpegpath, $flvtool2path, $mencoderpath, $phppath);
				break;
			case "generalsettings":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/settings.php");
				hwdvids_BE_settings::showgeneralsettings($option);
				break;
			case "homepagelayout":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/settings.php");
				hwdvids_BE_settings::showhomepagelayout($option);
				break;
			case "playerlayout":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/settings.php");
				hwdvids_BE_settings::showplayerlayout($option);
				break;
			case "savegeneral":
				require(HWDVS_ADMIN_PATH."/source/controllers/settings.php");
				hwdvids_BE_settings::savegeneral($option, $vpp, $fpfeaturedvids, $gpp, $fpfeaturedgroups, $aav, $aag, $aac, $hwdvids_language_path, $hwdvids_language_file, $hwdvids_template_path, $hwdvids_template_file, $diable_nav_videos, $diable_nav_catego, $diable_nav_groups, $diable_nav_upload, $radiusrc, $logconvert, $debugconvert, $deleteoriginal, $mailvideonotification, $mailgroupnotification, $mailnotifyaddress, $cbint, $disablelocupld, $flvplay_width, $flvplay_height, $disablecaptcha, $aa3v, $showcredit, $allowvidedit, $allowviddel, $locupldmeth, $requiredins, $maxupld, $flvplayer, $flvalign, $infoalign, $usershare1, $shareoption1, $usershare2, $shareoption2, $usershare3, $shareoption3, $usershare4, $shareoption4, $cbavatar, $avatarwidth, $gtree_core, $gtree_core_child, $gtree_upld, $gtree_upld_child, $gtree_grup, $gtree_grup_child, $thumbwidth, $reconvertflv, $abortthumbfail, $diable_nav_search, $diable_nav_user, $trunvdesc, $truncdesc, $trungdesc, $truntitle, $showrating, $showviews, $showduration, $showuplder, $autoconvert, $commssys, $gjint, $uploadcriteria, $ad1show, $ad1_ad_client, $ad1_ad_channel, $ad1_ad_type, $ad1_ad_uifeatures, $ad1_ad_format, $ad1_color_border1, $ad1_color_bg1, $ad1_color_link1, $ad1_color_text1, $ad1_color_url1, $ad1custom, $customencode, $encoder, $flvplay_autostart, $flvplay_overstretch, $flvplay_logo, $flvplay_volume, $flvplay_fg, $flvplay_bg, $fporder, $pathubr_upload, $cnvt_vbitrate, $cnvt_abitrate, $cnvt_asr, $cnvt_fsize, $usegetheaders, $ajaxratemeth, $ajaxfavmeth, $ajaxrepmeth, $ajaxa2gmeth, $cbitemid, $applywmvfix, $tpfunc, $diable_nav_user1, $diable_nav_user2, $diable_nav_user3, $diable_nav_user4, $diable_nav_user5, $showrate, $showatfb, $showrpmb, $showcoms, $showvurl, $showvebc, $showdesc, $showtags, $showscbm, $showuldr, $showa2gb, $gtree_plyr_child, $gtree_plyr);
				break;

			/** approval functions */
			case "approvals":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/approvals.php");
				hwdvids_BE_approvals::showapprovals($option);
				break;
			case "approve":
				require(HWDVS_ADMIN_PATH."/source/controllers/approvals.php");
				hwdvids_BE_approvals::approve( $cid, 1, $option );
				break;
			case "watchvideo":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/approvals.php");
				hwdvids_BE_approvals::watchvideo( $cid, 1, $option );
				break;

			/** reported-media functions */
			case "reported":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/reported.php");
				hwdvids_BE_flagged::showflagged($option);
				break;
			case "deleteReportedVideo":
				require(HWDVS_ADMIN_PATH."/source/controllers/reported.php");
				hwdvids_BE_flagged::deleteflaggedvid( $cid, $option );
				break;
			case "deleteReportedGroup":
				require(HWDVS_ADMIN_PATH."/source/controllers/reported.php");
				hwdvids_BE_flagged::deleteflaggedgroup( $cid, $option );
				break;
			case "readReportedVideo":
				require(HWDVS_ADMIN_PATH."/source/controllers/reported.php");
				hwdvids_BE_flagged::readflaggedvid( $cid, $option );
				break;
			case "readReportedGroup":
				require(HWDVS_ADMIN_PATH."/source/controllers/reported.php");
				hwdvids_BE_flagged::readflaggedgroup( $cid, $option );
				break;

			/** converter functions */
			case "converter":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/converter.php");
				hwdvids_BE_converter::converter($option);
				break;
			case "startconverter":
				require(HWDVS_ADMIN_PATH."/source/controllers/converter.php");
				hwdvids_BE_converter::startconverter($option, $cid);
				break;

			case 'resetFailedConversions':
				require(HWDVS_ADMIN_PATH."/source/controllers/converter.php");
				hwdvids_BE_converter::resetfconv($option);
				break;

			/** maintenance functions */
			case 'maintenance':
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/maintenance.php");
				hwdvids_BE_maintenance::maintenance($option);
				break;
			case 'runmaintenance':
				require(HWDVS_ADMIN_PATH."/source/controllers/maintenance.php");
				hwdvids_BE_maintenance::runmaintenance($option);
				break;

			case 'clearcache':
				require(HWDVS_ADMIN_PATH."/source/controllers/maintenance.php");
				hwdvids_BE_maintenance::clearCache($option);
				break;

			/** plugin functions */
			case "plugins":
			case "templates":
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/plugins.php");
				hwdvids_BE_plugins::showPlugins($option);
				break;
			case 'installPluginUpload':
				require(HWDVS_ADMIN_PATH."/source/controllers/plugins.php");
				hwdvids_BE_plugins::installPluginUpload();
				break;
			case 'deletePlugin':
				require(HWDVS_ADMIN_PATH."/source/controllers/plugins.php");
				hwdvids_BE_plugins::removePlugin( $cid, $option );
				break;
			case 'setPlugin':
				require(HWDVS_ADMIN_PATH."/source/controllers/plugins.php");
				hwdvids_BE_plugins::removePlugin( $cid, $option );
				break;
			case 'newPlugin':
			case 'editPlugin':
				require(HWDVS_ADMIN_PATH."/source/controllers/plugins.php");
				require(HWDVS_ADMIN_PATH."/plugin.class.php");
				hwdvids_BE_plugins::editPlugin( $option, $task,  $cid[0] );
				break;
			case 'publishPlugin':
			case 'unpublishPlugin':
				require(HWDVS_ADMIN_PATH."/source/controllers/plugins.php");
				hwdvids_BE_plugins::publishPlugin( $cid, ($task == 'publishPlugin'), $option );
				break;
			case 'cancelPlugin':
				require(HWDVS_ADMIN_PATH."/source/controllers/plugins.php");
				hwdvids_BE_plugins::cancelPlugin( $option );
				break;
			case 'savePlugin':
				require(HWDVS_ADMIN_PATH."/source/controllers/plugins.php");
				hwdvids_BE_plugins::savePlugin( $option );
				break;

			/** import functions */
			case 'import':
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/imports.php");
				hwdvids_BE_imports::import($option);
				break;

			case 'ftpupload':
				require(HWDVS_ADMIN_PATH."/source/controllers/imports.php");
				hwdvids_BE_imports::ftpupload($option);
				break;

			case 'remoteupload':
				require(HWDVS_ADMIN_PATH."/source/controllers/imports.php");
				hwdvids_BE_imports::remoteupload($option);
				break;

			case 'sqlrestore':
			case 'sqlRestore':
				require(HWDVS_ADMIN_PATH."/source/controllers/imports.php");
				hwdvids_BE_imports::sqlRestore($option);
				break;

			case 'csvimport':
			case 'csvImport':
				require(HWDVS_ADMIN_PATH."/source/controllers/imports.php");
				hwdvids_BE_imports::csvImport($option);
				break;

			case 'seyretimport':
			case 'seyretImport':
				require(HWDVS_ADMIN_PATH."/source/controllers/imports.php");
				hwdvids_BE_imports::seyretImport($option);
				break;

			case 'seyretimportundo':
			case 'seyretImportUndo':
				require(HWDVS_ADMIN_PATH."/source/controllers/imports.php");
				hwdvids_BE_imports::seyretImportUndo($option);
				break;

			case 'scandirectory':
				require(HWDVS_ADMIN_PATH."/source/controllers/imports.php");
				hwdvids_BE_imports::scanDirectory($option);
				break;

			case 'importdirectory':
				require(HWDVS_ADMIN_PATH."/source/controllers/imports.php");
				hwdvids_BE_imports::importDirectory($option);
				break;

			/** export functions */
			case 'export':
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/exports.php");
				hwdvids_BE_exports::backuptables($option);
				break;

			case 'botJombackup':
				checkdirstructure();
				require(HWDVS_ADMIN_PATH."/source/controllers/exports.php");
				hwdvids_BE_exports::botJombackup($option);
				break;

			/** default */
			default:
			homepage($option);
			break;
		}

   /**
	* show homepage
	*/
	function homepage($option)
	{
		global $database, $mainframe, $limitstart, $my, $Itemid, $mosConfig_live_site;
		$db =& JFactory::getDBO();

		$stats = array();

        $db->setQuery( "SELECT count(*) FROM #__hwdvidsvideos WHERE approved = \"pending\"" );
		$stats['approvals'] = $db->loadResult();

		$db->SetQuery( "SELECT count(*) FROM #__hwdvidsvideos WHERE approved = \"queuedforconversion\" AND approved = \"queuedforthumbnail\"" );
		$stats['conversion'] = $db->loadResult();

		$db->SetQuery( "SELECT count(*) FROM #__hwdvidsflagged_videos WHERE status = \"UNREAD\"" );
		$stats['reportedvideos'] = $db->loadResult();

		$db->SetQuery( "SELECT count(*) FROM #__hwdvidsflagged_groups WHERE status = \"UNREAD\"" );
		$stats['reportedgroups'] = $db->loadResult();

		$db->SetQuery( "SELECT count(*) FROM #__hwdvidsvideos" );
		$stats['totalvideos'] = $db->loadResult();

		$db->SetQuery( "SELECT count(*) FROM #__hwdvidscategories" );
		$stats['totalcategories'] = $db->loadResult();

		$db->SetQuery( "SELECT count(*) FROM #__users" );
		$stats['totalusers'] = $db->loadResult();

		$db->SetQuery( "SELECT id FROM #__users ORDER BY registerDate DESC" );
		$stats['latestuser'] = hwd_vs_tools::generateBEUserFromID($db->loadResult());

		$db->SetQuery( "SELECT count(*) FROM #__hwdvidsgroups" );
		$stats['totalgroups'] = $db->loadResult();

		$db->SetQuery( "SELECT id, group_name FROM #__hwdvidsgroups ORDER BY date DESC" );
		$latestgroup = $db->loadObject();
		if (!empty($latestgroup->id)) { $stats['latestgroup'] = "<a href=\"index2.php?option=com_hwdvideoshare&task=editgrpA&hidemainmenu=1&cid=".$latestgroup->id."\">$latestgroup->group_name</a>"; } else { $stats['latestgroup']=null; }

		$db->SetQuery( "SELECT count(*) FROM #__hwdvidsvideos WHERE date_uploaded >= DATE_SUB(NOW(),INTERVAL 1 DAY)" );
		$stats['totalvideostoday'] = $db->loadResult();

		$db->SetQuery( "SELECT count(*) FROM #__hwdvidsvideos WHERE date_uploaded >= DATE_SUB(NOW(),INTERVAL 7 DAY)" );
		$stats['totalvideosweek'] = $db->loadResult();

		$db->SetQuery( "SELECT * FROM #__hwdvidsvideos ORDER BY updated_rating DESC, rating_number_votes DESC LIMIT 0, 10" );
		$mostpopular = $db->loadObjectList();
		$db->SetQuery( "SELECT * FROM #__hwdvidsvideos ORDER BY number_of_views DESC LIMIT 0, 10" );
		$mostviewed = $db->loadObjectList();
		$db->SetQuery( "SELECT * FROM #__hwdvidsvideos ORDER BY date_uploaded DESC LIMIT 0, 10" );
		$mostrecent = $db->loadObjectList();
		$db->SetQuery( "SELECT * FROM #__hwdvidsgroups ORDER BY date DESC LIMIT 0, 10" );
		$recentgroups = $db->loadObjectList();

		hwdvids_HTML::homepage($option, $stats, $mostpopular, $mostviewed, $mostrecent, $recentgroups);
	}
	/**
	 * copyright notice
	 */
	function copyright()
	{
		include_once('version.php');
		$version = new hwdVideoShareVersion();
		$LongVersion = $version->getLongVersion();
		return "<div>".$LongVersion."<br />hwdMediaShare is created by <a href=\"http://hwdmediashare.co.uk\" target=\"_blank\">Highwood Design</a></div>";
	}
   /**
    * check the external hwdvideos directory structure exists
    */
	function checkdirstructure()
	{
		global $database, $mainframe, $limitstart, $Itemid;
		$filepath = array();
		$filepath[0] = JPATH_SITE."/hwdvideos/";
		$filepath[1] = JPATH_SITE."/hwdvideos/backups/";
		$filepath[2] = JPATH_SITE."/hwdvideos/plugin/";
		$filepath[3] = JPATH_SITE."/hwdvideos/plugin/language/";
		$filepath[4] = JPATH_SITE."/hwdvideos/plugin/templates/";
		$filepath[5] = JPATH_SITE."/hwdvideos/plugin/thirdparty/";
		$filepath[6] = JPATH_SITE."/hwdvideos/thumbs/";
		$filepath[7] = JPATH_SITE."/hwdvideos/uploads/";
		$filepath[8] = JPATH_SITE."/hwdvideos/uploads/originals/";
		$filepath[9] = JPATH_SITE."/components/com_hwdvideoshare/converters/logs/";
		$filepath[10] = JPATH_SITE."/components/com_hwdvideoshare/uploads/flash/files/";
		$filepath[11] = JPATH_SITE."/components/com_hwdvideoshare/core/templates/templates_c/";
		$filepath[12] = JPATH_SITE."/components/com_hwdvideoshare/xml/cache/";
		$filepath[13] = JPATH_SITE."/administrator/components/com_hwdvideoshare/maintenance/cache/";
		foreach ($filepath as $path) {
			if (file_exists($path)) {
				if (!is_writable($path)) {
					echo "<div style=\"border:2px solid #c30;color:#c30;margin-bottom:2px;padding:5px;\">"._HWDVIDS_ALERT_MANCHMOD." <b>".$path."</b></div>";
				}
			} else {
				echo "<div style=\"border:2px solid #c30;color:#c30;margin-bottom:2px;padding:5px;\">"._HWDVIDS_ALERT_MANMKDIR." <b>".$path."</b></div>";
			}
		}
	}
   /**
    * check the external hwdvideos directory structure exists
    */
	function initialise_setup()
	{
		global $database, $mainframe, $limitstart, $my, $Itemid;
		$db =& JFactory::getDBO();

		$cats    		= JRequest::getInt( 'cats', 0, 'post' );
		$youtube 		= JRequest::getInt( 'youtube', 0, 'post' );
		$google  		= JRequest::getInt( 'google', 0, 'post' );
		$jwflv_license  = JRequest::getInt( 'jwflv_license', 0, 'post' );

		if ($cats == 1) {
			$db->setQuery( 'INSERT IGNORE INTO `#__hwdvidscategories` (`id`, `parent`, `category_name`, `category_description`, `date`, `access_b_v`, `access_u_r`, `access_v_r`, `access_u`, `access_v`, `ordering`, `num_vids`, `num_subcats`, `checked_out`, `checked_out_time`, `published`)'
								.'VALUES (1, 0, \'Cars &amp; Vehicles\', \'Cars, Classic cars, Motorcycles &amp; Scooters, Campers, Caravans &amp; Motorhomes, Commercial Vehicles, Aircraft &amp; Aviation, Boats &amp; Watercraft, Other Vehicles\', \'0000-00-00 00:00:00\', 0, \'RECURSE\', \'RECURSE\', -2, -2, 0, 0, 0, 0, \'0000-00-00 00:00:00\', 1),'
								.'(2, 0, \'Comedy\', \'Sketches, Stand-up &amp; Spoofs\', \'0000-00-00 00:00:00\', 0, \'RECURSE\', \'RECURSE\', -2, -2, 1, 0, 0, 0, \'0000-00-00 00:00:00\', 1),'
								.'(3, 0, \'Entertainment\', \'Films &amp; Television\', \'0000-00-00 00:00:00\', 0, \'RECURSE\', \'RECURSE\', -2, -2, 2, 0, 0, 0, \'0000-00-00 00:00:00\', 1),'
								.'(4, 0, \'Film &amp; Animation\', \'Short Films, Stop-motion &amp; Animation\', \'0000-00-00 00:00:00\', 0, \'RECURSE\', \'RECURSE\', -2, -2, 3, 0, 0, 0, \'0000-00-00 00:00:00\', 1),'
								.'(5, 0, \'How To &amp; Style\', \'Instruction, Ideas &amp; Training\', \'0000-00-00 00:00:00\', 0, \'RECURSE\', \'RECURSE\', -2, -2, 4, 0, 0, 0, \'0000-00-00 00:00:00\', 1),'
								.'(6, 0, \'Music\', \'Bands, Singers &amp; Songwriters\', \'0000-00-00 00:00:00\', 0, \'RECURSE\', \'RECURSE\', -2, -2, 5, 0, 0, 0, \'0000-00-00 00:00:00\', 1),'
								.'(7, 0, \'News &amp; Politics\', \'Current Events &amp; Commentaries\', \'0000-00-00 00:00:00\', 0, \'RECURSE\', \'RECURSE\', -2, -2, 6, 0, 0, 0, \'0000-00-00 00:00:00\', 1),'
								.'(8, 0, \'People &amp; Blogs\', \'Personalities, Biographies &amp; Artists\', \'0000-00-00 00:00:00\', 0, \'RECURSE\', \'RECURSE\', -2, -2, 7, 0, 0, 0, \'0000-00-00 00:00:00\', 1),'
								.'(9, 0, \'Pets &amp; Animals\', \'Dogs &amp; Cats\', \'0000-00-00 00:00:00\', 0, \'RECURSE\', \'RECURSE\', -2, -2, 8, 0, 0, 0, \'0000-00-00 00:00:00\', 1),'
								.'(10, 0, \'Sport\', \'Extreme, Competitions &amp; Skateboarding\', \'0000-00-00 00:00:00\', 0, \'RECURSE\', \'RECURSE\', -2, -2, 9, 0, 0, 0, \'0000-00-00 00:00:00\', 1),'
								.'(11, 0, \'Travel &amp; Events\', \'Holidays, Nature &amp; Monuments\', \'0000-00-00 00:00:00\', 0, \'RECURSE\', \'RECURSE\', -2, -2, 10, 0, 0, 0, \'0000-00-00 00:00:00\', 1);'
								);
			if ( !$db->query() ) {
				echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
				exit();
			}
		}

		if ($google == 1) {
			$query = 'DELETE FROM `#__hwdvidsplugin` WHERE `id` = 1;';
			$db->setQuery( $query );
			if ( !$db->query() ) {
				echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
				exit();
			}
			$query = 'INSERT IGNORE INTO `#__hwdvidsplugin` (`id`, `name`, `element`, `type`, `folder`, `access`, `ordering`, `published`, `iscore`, `client_id`, `checked_out`, `checked_out_time`, `website`, `playlist_compat`, `params`)'
					.'VALUES (1, \'GoogleVideo\', \'google\', \'thirdparty\', \'../../../components/com_hwdvideoshare/core/google\', 0, 99, 1, 1, 211, 0, \'0000-00-00 00:00:00\', \'http://video.google.com\', \'\', \'\');'
					;
			$db->setQuery( $query );
			if ( !$db->query() ) {
				echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
				exit();
			}
		}
		if ($youtube == 1) {
			$query = 'DELETE FROM `#__hwdvidsplugin` WHERE `id` = 2;';
			$db->setQuery( $query );
			if ( !$db->query() ) {
				echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
				exit();
			}
			$query = 'INSERT IGNORE INTO `#__hwdvidsplugin` (`id`, `name`, `element`, `type`, `folder`, `access`, `ordering`, `published`, `iscore`, `client_id`, `checked_out`, `checked_out_time`, `website`, `playlist_compat`, `params`)'
					.'VALUES (2, \'YouTube\', \'youtube\', \'thirdparty\', \'../../../components/com_hwdvideoshare/core/youtube\', 0, 99, 1, 1, 211, 0, \'0000-00-00 00:00:00\', \'http://www.youtube.com\', \'\', \'\');'
					;
			$db->setQuery( $query );
			if ( !$db->query() ) {
				echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
				exit();
			}
		}
		// Backend Remote Server Support
		$query = 'DELETE FROM `#__hwdvidsplugin` WHERE `id` = 3;';
		$db->setQuery( $query );
		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}
		$query = 'INSERT IGNORE INTO `#__hwdvidsplugin` (`id`, `name`, `element`, `type`, `folder`, `access`, `ordering`, `published`, `iscore`, `client_id`, `checked_out`, `checked_out_time`, `params`)'
				.'VALUES (3, \'Backend Remote Server Support\', \'remote\', \'thirdparty\', \'../../../components/com_hwdvideoshare/core/remote\', 0, 99, 0, 1, 211, 0, \'0000-00-00 00:00:00\', \'\');'
				;
		$db->setQuery( $query );
		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}
		// JW FLV
		$query = 'DELETE FROM `#__hwdvidsplugin` WHERE `id` = 4;';
		$db->setQuery( $query );
		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}
		if ($jwflv_license == 0 || $jwflv_license == 2) {
			$query = 'INSERT IGNORE INTO `#__hwdvidsplugin` (`id`, `name`, `element`, `type`, `folder`, `access`, `ordering`, `published`, `iscore`, `client_id`, `checked_out`, `checked_out_time`, `website`, `playlist_compat`, `params`)'
					.'VALUES (4, \'JW FLV Player\', \'jwflv\', \'videoplayer\', \'../../../components/com_hwdvideoshare/core/videoplayer/jwflv\', 0, 99, 1, 0, 211, 0, \'0000-00-00 00:00:00\', \'\', \'\', \'\');'
					;
			$db->setQuery( $query );
			if ( !$db->query() ) {
				echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
				exit();
			}
		}
		// OS FLV
		$query = 'DELETE FROM `#__hwdvidsplugin` WHERE `id` = 5;';
		$db->setQuery( $query );
		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}
		$query = 'INSERT IGNORE INTO `#__hwdvidsplugin` (`id`, `name`, `element`, `type`, `folder`, `access`, `ordering`, `published`, `iscore`, `client_id`, `checked_out`, `checked_out_time`, `params`)'
				.'VALUES (5, \'OS FLV Player\', \'osflv\', \'videoplayer\', \'../../../components/com_hwdvideoshare/core/videoplayer/osflv\', 0, 99, 1, 1, 211, 0, \'0000-00-00 00:00:00\', \'\');'
				;
		$db->setQuery( $query );
		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$db->SetQuery("UPDATE #__hwdvidsgs SET value = 0 WHERE setting = \"initialise_now\"");
		$db->Query();
		if ( !$db->query() ) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}
		$mainframe->enqueueMessage('Setup Completed');
		$mainframe->redirect( JURI::root( true ) . '/administrator/index2.php?option=com_hwdvideoshare' );
	}
?>